function [C,f, confC]=plot_mv_mpP_cc(mv_mpP,figurenum,timebounds)
%plots velocities for multiple mv_mpP objects
if strcmp(timebounds,'all')
    mintime=0.5;
    maxtime=max(mv_mpP(1).Blood_flow.the_t);
else
    mintime=min(timebounds);
    maxtime=max(timebounds);
end

mintime_all=0.5;
    maxtime_all=max(mv_mpP(1).Blood_flow.the_t);

nvessels=length(mv_mpP)
oktimes=intersect(find(mv_mpP(1).Blood_flow.the_t>mintime),find(mv_mpP(1).Blood_flow.the_t<maxtime));
figure(figurenum)
%vessel_colors={'b' 'r' 'g' 'k' 'c' 'm' 'y' 'b' 'r' 'g' 'k' 'c' 'm' 'y' };
vessel_colors={[0 1 0] [1 0 0] [0 0 1] [0 1 1] [1 1 0] [1 0 1]};%
subplot(411)%plot the raw data
hold_image=[];
timedecimate=1;
try
    for v=1:nvessels
        hold_image=[ hold_image;ones(1,length(mv_mpP(v).Blood_flow.Image(:,1:timedecimate:end)))*double(mean( mv_mpP(1).Blood_flow.Image(:))); mv_mpP(v).Blood_flow.Image(:,1:timedecimate:end)];
    end
    imagesc(timedecimate*[1:size(hold_image,2)]/mv_mpP(1).Tfactor,[1:size(hold_image,1)]*mv_mpP(1).Xfactor,(double(hold_image)))
    caxis([1 0.95*max(mv_mpP(v).Blood_flow.Image(:))])
    xlabel('time, seconds')
    ylabel('distance, microns')
    axis([mintime maxtime 0 size(hold_image,1)*mv_mpP(1).Xfactor])
end

%eCoG stuff
try
Fs_ECoG=length(mv_mpP(1).Ch3)/str2num(mv_mpP(1).Header.Frame_Count)*5/4%(1/(str2num(mv_mpP(1).Header.Pixel_Clock)*(.05*1e-6)))/1000%/mv_mpP(v).ysize*(mv_mpP(v).ysize*mv_mpP(v).xsize)/1000%length(mpP.Ch3)/duration
%Fs_ECoG=mv_mpP(v).Header.LineRate/mv_mpP(v).ysize*1000;%length(mpP.Ch3)/duration
mv_mpP(v).Fs_ECoG=Fs_ECoG;%(length(mpP.ECoG.trials(1))/(mpP.nframes_per_trial))*((mpP.xsize*mpP.ysize*5/4)*(str2num(mpP.Header.Pixel_Clock)*.05*(1e-6)))
params_ECoG.Fs=Fs_ECoG;
params_ECoG.tapers=[5 9];%5 9
params_ECoG.trialave=0;
params_ECoG.fpass=[0 100];
    [S_ECoG,t_ECoG,f_ECoG]=mtspecgramc(double(diff(mv_mpP(1).ECoG.raw)),[2 .25],params_ECoG);
    subplot(413)
    imagesc(t_ECoG,f_ECoG,log10(S_ECoG)')%
    axis xy
    axis([mintime maxtime params_ECoG.fpass ])
catch
    disp('ecog specgram fail')
end
%%
subplot(412)
hold off
for v=1:nvessels
    [mv_mpP(v),fixed_v_noHR]=HeartRateRemove2(mv_mpP(v));
    seperability=mv_mpP(v).Blood_flow.seperability;%max(squeeze(mean(mpP.Blood_flow.spread_matrix_adaptive,1))')./mean(squeeze(mean(mpP.Blood_flow.baseline_var,1))');%
    sep_threshold=3;
    low_sep=find(seperability<sep_threshold);
    sep=find(seperability>=sep_threshold);
    vel_sign=sign(mean(mv_mpP(v).Blood_flow.fixed_v));
    fixed_v_plot{v}=(mv_mpP(v).Blood_flow.fixed_v);
    outliers=union(find(mv_mpP(v).Blood_flow.fixed_v*vel_sign>vel_sign*(median(mv_mpP(v).Blood_flow.fixed_v))+2*std(mv_mpP(v).Blood_flow.fixed_v)),find(vel_sign*mv_mpP(v).Blood_flow.fixed_v<vel_sign*median(mv_mpP(v).Blood_flow.fixed_v)-2*std(mv_mpP(v).Blood_flow.fixed_v)))
     fixed_v_plot{v}(outliers)=mean(mv_mpP(v).Blood_flow.fixed_v);
    fixed_v_plot_noHR{v}=mv_mpP(v).Blood_flow.fixed_v_noHR;
    for the_point=sep
        try
            fixed_v_plot{v}(the_point)=median(fixed_v_plot(the_point+[-1 1]));
            fixed_v_plot_noHR{v}(the_point)=median(fixed_v_plot(the_point+[-1 1]));
        end
    end


    plot(mv_mpP(v).Blood_flow.the_t,abs((fixed_v_plot{v})),'Color',vessel_colors{v})
    hold on
    plot(mv_mpP(v).Blood_flow.the_t,abs(fixed_v_plot_noHR{v}),'Color',vessel_colors{v}*.5)
    mean_velocity(v)=mean(mv_mpP(v).Blood_flow.fixed_v(sep))/1000% in mm/sec
end

axis([mintime maxtime min(min(0,(abs(mv_mpP(1).Blood_flow.fixed_v(:))))) 2000*max(0,max(abs(mean_velocity)))])
xlabel('seconds')
ylabel('\mu/sec')
title('velocity trace')
legend(num2str([1:nvessels]'))



subplot(427) %plot the spectrum
params.Fs=1/(mv_mpP(1).Blood_flow.the_t(2)-mv_mpP(1).Blood_flow.the_t(1));
params.tapers=[25 49];
params.err=[1 .05];
try
for v=1:nvessels
    [S{v},f{v}]=mtspectrumc((fixed_v_plot{v})-mean(fixed_v_plot{v}),params);
end
catch
    params.tapers=[15 29];
    for v=1:nvessels
    [S{v},f{v}]=mtspectrumc((fixed_v_plot{v})-mean(fixed_v_plot{v}),params);
    end
end
hold off
for v=1:nvessels
    loglog(f{v},S{v},'Color',vessel_colors{v})
    hold on
end
legend(num2str([1:nvessels]'))
axis([0.1 20 2 1000])
subplot(428) %plot the coherence
hold off
colorcount=1;
params.err=[1 .01];
params.tapers=[15 29];
if nvessels>1
    for u=1:nvessels
        for v=u+1:nvessels
            [C{u,v},phi{u,v},S12{u,v},S1{u,v},S2{u,v},f{u,v},confC{u,v},Cerr{u,v}]=coherencyc(...
                (fixed_v_plot{u})'-mean(fixed_v_plot{u}), (fixed_v_plot{v}')-mean(fixed_v_plot{v}),params);
            semilogx(f{u,v},C{u,v},'Color',vessel_colors{colorcount})
            hold on
            coherence_legend{colorcount}=['C ' num2str(u) '-'  num2str(v)];
            colorcount=1+colorcount;
        end
    end
    legend(coherence_legend)
    colorcount=1;
    for u=1:nvessels
        for v=u+1:nvessels
            plot(f{u,v},confC{u,v},['.-'],'Color', vessel_colors{colorcount})
            colorcount=1+colorcount;
        end
    end
end
axis([0.1 20 0 1])
%plot transferfuntion
subplot(425)
transfer_window=256*4;

[Txy21,Fxy21]=tfestimate(fixed_v_plot{2}'-mean(fixed_v_plot{2}),fixed_v_plot{1}'-mean(fixed_v_plot{1}),transfer_window,transfer_window/16,[],mv_mpP(1).Blood_flow.the_Fs);
[Txy12,Fxy12]=tfestimate(fixed_v_plot{1}'-mean(fixed_v_plot{1}),fixed_v_plot{2}'-mean(fixed_v_plot{2}),transfer_window,transfer_window/16,[],mv_mpP(1).Blood_flow.the_Fs);
hold off
semilogx(Fxy21,abs(Txy21)/max(abs(Txy21)))
hold on
semilogx(Fxy12,abs(Txy12)/max(abs(Txy12)),'r')
semilogx(Fxy12,abs(Txy12)/max(abs(Txy12)).*abs(Txy12)/max(abs(Txy12)),'m')
%loglog(Fxy,1./abs(Txy))


subplot(426) %plot pahse infor
semilogx(Fxy12,angle(Txy12))

% colorcount=1
% hold off
% for u=1:nvessels
%         for v=u+1:nvessels
%             semilogx(f{u,v},rem((phi{u,v}),2*pi),'Color',vessel_colors{colorcount})
%             hold on
%             coherence_legend{colorcount}=['C ' num2str(u) '-'  num2str(v)];
%             colorcount=1+colorcount;
%         end
%     end
% 

figure(figurenum+1)
ncoheregrams=(nvessels-1)*(nvessels);
coheregramcount=1;
params.Fs=1/(mv_mpP(1).Blood_flow.the_t(2)-mv_mpP(1).Blood_flow.the_t(1));
params.err=[1 0.001]
params.fpass=[0 20];
for u=1:nvessels
    for v=u+1:nvessels
        subplot(ncoheregrams/2,1,coheregramcount)
        [C_gram{u,v},phi_gram{u,v},S12_gram{u,v},S1_gram{u,v},S2_gram{u,v},t_gram{u,v},f_gram{u,v},confC_gram{u,v},Cerr_gram{u,v}]=cohgramc(...
            fixed_v_plot{u}'-mean((fixed_v_plot{u})),fixed_v_plot{v}'-mean(fixed_v_plot{v}), [5 1], params);
        hold off
        imagesc(t_gram{u,v},f_gram{u,v},C_gram{u,v}')
        axis xy
        coheregramcount=coheregramcount+1
        hold on
        contour(t_gram{u,v},f_gram{u,v},C_gram{u,v}',confC_gram{u,v}'*[1 1],'r')
        %plot(the_contour_x{coheregramcount}(1,:),the_contour_x{coheregramcount}(2,:),'r')
        title(['Coherence ' num2str(u) '--' num2str(v)])
        caxis([0 1])
        xlabel('time,sec')
        ylabel('freq, Hz')
    end
end
figure(figurenum-1)
subplot(341)

colormap gray
hold off
imagesc((mv_mpP(1).scanData.im-min(mv_mpP(1).scanData.im(:))+1))
caxis([0 prctile((mv_mpP(1).scanData.im(:)-min(mv_mpP(1).scanData.im(:))+1),98)])

axis image
hold on
pathImCoords(:,1) = mv_mpP(1).scanData.path(:,1) * (size(mv_mpP(1).scanData.im,2)-1)/(abs(diff(mv_mpP(1).scanData.axisLimCol))) + 1 - (size(mv_mpP(1).scanData.im,2)-1)/(abs(diff(mv_mpP(1).scanData.axisLimCol)))*min(mv_mpP(1).scanData.axisLimCol);
pathImCoords(:,2) = mv_mpP(1).scanData.path(:,2) * (size(mv_mpP(1).scanData.im,1)-1)/(abs(diff(mv_mpP(1).scanData.axisLimRow))) + 1 - (size(mv_mpP(1).scanData.im,1)-1)/(abs(diff(mv_mpP(1).scanData.axisLimRow)))*min(mv_mpP(1).scanData.axisLimRow);
pathImColor= mv_mpP(1).scanData.pathObjNum+1;

for k=1:length(pathImCoords)
    hold on
plot(pathImCoords(k,1),pathImCoords(k,2),'Color', vessel_colors{pathImColor(k)})
end
axis off

%plot the raw data and velocity
rawdataplotspots={(2:4) (14:16)};
velplotspots={(6:8) (18:20)}
longvelplotspots={(10:12) (22:24)}

%%
subplot(345) %plot the spectrum
params.Fs=1/(mv_mpP(1).Blood_flow.the_t(2)-mv_mpP(1).Blood_flow.the_t(1));
params.tapers=[25 49];
params.err=[1 .05];
params.fpass=[.1 20]
try
for v=1:nvessels
    [Spsd{v},fpsd{v}]=mtspectrumc((fixed_v_plot{v})-mean(fixed_v_plot{v}),params);
end
catch
    params.tapers=[15 29];
    for v=1:nvessels
    [Spsd{v},fpsd{v}]=mtspectrumc((fixed_v_plot{v})-mean(fixed_v_plot{v}),params);
    end
end
hold off
for v=1:nvessels
    loglog(fpsd{v},Spsd{v},'Color',vessel_colors{v})
    hold on
end
legend(num2str([1:nvessels]'))
axis tight% ([0.1 20 2 1000])
axis square

%%


for v=1:2%length(mv_mpP)
subplot(6,4,rawdataplotspots{v})
hold_image=filter2(gaussian2d(1,2,6,6),[ mv_mpP(v).Blood_flow.Image(1:timedecimate:end,:)'],'same');
try
imagesc(timedecimate*[1:size(hold_image,1)]/mv_mpP(1).Tfactor,[1:size(hold_image,2)]*mv_mpP(1).Xfactor,(double(hold_image')))
colormap gray
caxis([0 prctile(double(hold_image(:)),98)])
axis([mintime maxtime 0 size(hold_image,2)*mv_mpP(1).Xfactor])
title(mv_mpP(v).Header.Filename);%['stim=' num2str(mv_mpP(v).the_stim(example_trial_number))])
xlabel('time, seconds')
ylabel('distance, microns')
catch
disp('image fail!')
end
subplot(6,4,velplotspots{v})
hold off
[mv_mpP(v),fixed_v_noHR]=HeartRateRemove(mv_mpP(v));

seperability=mv_mpP(v).Blood_flow.seperability;%
sep_threshold=3;
low_sep=find(seperability<sep_threshold);
ok_sep=find(seperability>=sep_threshold);
valid_points{v}=double(seperability>=sep_threshold);
fixed_v_plot{v}=mv_mpP(v).Blood_flow.fixed_v_noHR;
fixed_v_plot_for_cohere{v}=fixed_v_plot{v};
fixed_v_plot{v}(low_sep)=NaN;
size(fixed_v_plot{v})
plot(mv_mpP(v).Blood_flow.the_t,fixed_v_plot{v})
hold on
plot(mv_mpP(v).Blood_flow.the_t,abs(mv_mpP(v).Blood_flow.fixed_v_noHR),'k')
axis([mintime maxtime 0 1.2*max(abs(mv_mpP(v).Blood_flow.fixed_v))])
%plot(mv_mpP(v).Blood_flow.the_t,median(sign(mean(mv_mpP(v).Blood_flow.fixed_v(:)))*valid_points{v}(stim_trials{thestim},:).*(mv_mpP(v).Blood_flow.fixed_v(stim_trials{thestim},:)))+std_no,stimcolors{thestim},.0)
mean_velocity(v)=mean(mv_mpP(v).Blood_flow.fixed_v(ok_sep))/1000% in mm/sec
xlabel('seconds')
ylabel('mm/sec')
title(['velocity trace vessel ' num2str(v)])


subplot(6,4,longvelplotspots{v})
hold off
[mv_mpP(v),fixed_v_noHR]=HeartRateRemove(mv_mpP(v));

seperability=mv_mpP(v).Blood_flow.seperability;%
sep_threshold=3;
low_sep=find(seperability<sep_threshold);
ok_sep=find(seperability>=sep_threshold);
valid_points{v}=double(seperability>=sep_threshold);
fixed_v_plot{v}=mv_mpP(v).Blood_flow.fixed_v_noHR;
fixed_v_plot_for_cohere{v}=fixed_v_plot{v};
fixed_v_plot{v}(low_sep)=NaN;
size(fixed_v_plot{v})
plot(mv_mpP(v).Blood_flow.the_t,fixed_v_plot{v})
hold on
plot(mv_mpP(v).Blood_flow.the_t,abs(mv_mpP(v).Blood_flow.fixed_v_noHR),'k')
axis([mintime_all maxtime_all 0 1.2*max(abs(mv_mpP(v).Blood_flow.fixed_v))])
%plot(mv_mpP(v).Blood_flow.the_t,median(sign(mean(mv_mpP(v).Blood_flow.fixed_v(:)))*valid_points{v}(stim_trials{thestim},:).*(mv_mpP(v).Blood_flow.fixed_v(stim_trials{thestim},:)))+std_no,stimcolors{thestim},.0)
mean_velocity(v)=mean(mv_mpP(v).Blood_flow.fixed_v(ok_sep))/1000% in mm/sec
xlabel('seconds')
ylabel('mm/sec')
title(['velocity trace vessel ' num2str(v)])







end
subplot(3,4,9)
hold off
colorcount=1
 for u=1:nvessels
        for v=u+1:nvessels
            semilogx(f{u,v},C{u,v},'Color',vessel_colors{colorcount})
                       hold on

                       colorcount=1+colorcount;
        end
    end
axis([.1 20 0 1])
axis square





